/*
   Programa de Control de Matrculas
   segn dos tipos de formatos:

   - antiguo (VI1234P)
   - europeo (9876BCT)

   */

import javabook.*;

class Matri
{
   /***********************
      Datos Miembro
   ***********************/

   private MainWindow  ventanaPrincipal;
   private InputBox    cuadroEntrada;
   private OutputBox   cuadroSalida;
   private MessageBox  cuadroMensaje;
   private ResponseBox cuadroRespuesta;

   private String mat;

   /***********************
      Constructor
   ***********************/

   public Matri()
   {
      ventanaPrincipal   = new MainWindow("Validacin de Matrculas");
      cuadroSalida       = new OutputBox(ventanaPrincipal);
      cuadroMensaje      = new MessageBox(ventanaPrincipal);
      cuadroRespuesta    = new ResponseBox(ventanaPrincipal);
      cuadroEntrada      = new InputBox(ventanaPrincipal);

      ventanaPrincipal.show();
      cuadroSalida.show();
   }

   /***********************
      Mtodos Pblicos
   ***********************/

   public void empezar ()
   {
      boolean valida = true;

      do
      {
         leerMatricula();
         valida = validarLongitud();
         if (valida)
         	if (mat.substring(0,2).equals("VI"))
         	   valida = validarMatAntigua();
         	else
         	   valida = validarMatEuropea();

      } while (valida == false);
   }

   /***********************
      Mtodos Privados
   ***********************/

   private void leerMatricula()
   {
      mat = cuadroEntrada.getString("Introduzca la matrcula del vehculo: ");
   }

   private boolean validarLongitud()
   {
      if (mat.length() != 7)
      	 cuadroMensaje.show ("La longitud de la matrcula debe ser 7. Repetir ");
      return (mat.length() == 7);
   }

   private boolean validarMatAntigua()
   {
	  boolean correcta1 = true, correcta2 = true;

	  String numericaAnt = mat.substring(2, 6);
      correcta1 = validarNumerica(numericaAnt);
      if (!correcta1)
      	 cuadroMensaje.show("Las posiciones 3, 4, 5 y 6 deben ser nmeros. Repetir ");

      char ultPos = mat.charAt(6);
	  correcta2 = validarLetra(ultPos);
	  if (!correcta2)
	     cuadroMensaje.show("La ltima letra no puede ser vocal ni '' ni 'Q'. Repetir ");

	  return (correcta1 && correcta2);
   }

   private boolean validarMatEuropea()
   {
	   boolean correcta1 = true, correcta2 = true;

	   String numericaEurop = mat.substring(0, 4);
	   correcta1 = validarNumerica(numericaEurop);
	   if (!correcta1)
	   	  cuadroMensaje.show("Las cuatro primeras posiciones deben ser numricas. Repetir ");

       correcta2 = validarLetra(mat.charAt(4)) && validarLetra(mat.charAt(5)) && validarLetra(mat.charAt(6));
       if (!correcta2)
       	  cuadroMensaje.show("Las tres ltimas posiciones alfabticas no pueden contener vocales ni '' ni 'Q'. Repetir ");

       return (correcta1 && correcta2);
   }

   private boolean validarNumerica(String num)
   {
      boolean correcta = true;
      int longitud = num.length();
	  int i =0;

      while( i <= longitud-1 && correcta == true)
	  {
	  	 char aux = num.charAt(i);
		 if( aux < '0' || aux > '9')
		  	correcta = false;

		 i++;
	  }

      return correcta;
   }

   private boolean validarLetra (char letra)
   {
	  return (letra != 'A' && letra != 'E' &&
	          letra != 'I' && letra != 'O' && letra != 'U' &&
	          letra != '' && letra != 'Q' &&
	          letra >= 'A' && letra <='Z');
   }

}
